<!DOCTYPE html>
<html>

<head>
	<meta charset="UTF-8">
	<title>Form work1</title>
	<style>
		#colors {
			width: 200px;
	
			display: flex;
			flex-wrap: wrap;
		}
	
		.result {
			width: 50px;
			background: gray;
			box-sizing: border-box;
			padding: 10px;
		}
	
		#MyValidateForm {
			width: 350px;
			display: flex;
			flex-direction: column;
		}
	
		#MyValidateForm input {
			margin-bottom: 10px;
			box-sizing: border-box;
			padding: 10px 20px;
		}
	
		.circle {
			width: 30px;
			height: 30px;
			background: #eee;
			border-radius: 50%;
		}

		#colors ul {
			width: 300px;
			height: auto;
			display: flex;
			flex-wrap: wrap;
			margin: 0;
			padding: 0;
			list-style: none;
		}

		#colors li {
			
			width: 38px;
			height: 38px;
			border-radius: 50%;
			margin-left: 5px;
			margin-bottom: 5px;
			cursor: pointer;
		}

		#colors li.active {
			position: relative;
		}

		#colors li::before {
			position: absolute;
			width: 16px;
			height: 10px;
			left: calc(50% - 10px);
			top: calc(50% - 10px);
			border-left: 4px solid #fff;
			border-bottom: 4px solid #fff;
			transform: rotate(-45deg) scale(0);
			transition: all 300ms;
			content: '';
		}

		#colors li.active::before {
			transform: rotate(-45deg) scale(1);
			transition: all 300ms;
		}
	</style>

</head>

<body>
	<div class="Templating">
		<form>
			<input type="range" id="myWidth" min="10" max="500" step="10" />
			<input type="color" id="myColor" min="10" max="500" step="10" />
			<input type="range" id="myHeight" min="10" max="500" step="10" />
			<input type="range" id="myBorderRad" min="10" max="500" step="10" />
			<input type="range" id="myMargin" min="10" max="500" step="10" />
		</form>

		<div class="TemplatingResult">
			<div id="result" class="result"></div>
		</div>
	</div>


	<div id="colors">
		<button id="choice">
			Выбор рандомных цветов

		</button>

	</div>




	<script>
		/*
			Задание:
				Сделать шиблонизатор элемента по:
				Ширине input type=range
				Цвету  input type=color
				Высоте input type=number
				Скругление углов input type=number
				Margin input type=number
 
			Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference
 
			Бонус:
				+ Сделать выборку цвета из рандомных 20 цветов которые выбираются из появившегося блока :
				https://s3.envato.com/files/230412754/screenshots/1.png
				За заготовку для рандома цвета использовать функцию из первых занятий.
 
		*/

		window.addEventListener("load", function () {
			var myWidth = document.getElementById('myWidth');
			var myColor = document.getElementById('myColor');
			var myHeight = document.getElementById('myHeight');
			var myBorderRad = document.getElementById('myBorderRad');
			var myMargin = document.getElementById('myMargin');
			var colors = document.getElementById('colors');
			var choice = document.getElementById('choice');
			var result = document.getElementById('result');

			myWidth.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.width = event.target.value + 'px';
			});

			myColor.addEventListener('input', function () {
				console.log(myColor.value);
				result.style.background = myColor.value;
			});

			myHeight.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.height = event.target.value + 'px';
			});

			myHeight.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.height = event.target.value + 'px';
			});

			myBorderRad.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.borderRadius = (event.target.value / 10) + '%';
			});

			myMargin.addEventListener('input', function (event) {
				console.log(event.target.value);
				result.style.margin = event.target.value + 'px';
			});

			function getRandomIntInclusive(min, max) {
				var min = Math.ceil(min);
				var max = Math.floor(max);
				return Math.floor(Math.random() * (max - min + 1)) + min;
			};
			var a = document.createElement('ul');

			choice.addEventListener('click', function () {
		 
				color = [];
				for (i = 0; i < 20; i++) {
					var sixteencolor = "#" + getRandomIntInclusive(20, 200).toString(16) + getRandomIntInclusive(15, 180).toString(16) + getRandomIntInclusive(22, 222).toString(16) + "";
					color.push(sixteencolor)
				}
				// var y = "#" + color[0] + color[1] + color[2] + "";
				// console.log(y); 
				console.log(color);
				a.innerHTML = '';
				colors.appendChild(a);
				for (i = 0; i < color.length; i++){
					var c = document.createElement('li');
					c.style.background = color[i];
					a.appendChild(c);
				}

				var items = a.querySelectorAll('li');
				items.forEach((element, i) => {
					element.addEventListener('click', () => {
						items.forEach((el) => {
							el.classList.remove('active')
						})
						element.classList.add('active');
						
						result.style.backgroundColor = color[i];
					})
				});

				
			})



			
		});

	</script>
</body>

</html>